export interface ICoordinates {
    x: number
    y: number
    z: number
}

export interface IRotation {
    yaw: number
    pitch: number
}

export interface IVelocity {
    velocityX: number
    velocityY: number
    velocityZ: number
}

export interface IDelta {
    dX: number
    dY: number
    dZ: number
}

export interface IPosition extends ICoordinates, IRotation { }
export interface IMovable extends IPosition, IVelocity { }

export interface ISlot {
    present: boolean
    itemId: number
    itemCount: number
    nbtData: object
    //TODO:
}

export type gameMode = 0|1|2|3
export interface IState {
    entityId: number,
    gamemode: gameMode,
    dimension: number,
    hashedSeed: number[],
    maxPlayers: number,
    levelType: string,
    viewDistance: number,
    reducedDebugInfo: boolean,
    enableRespawnScreen: boolean
}

export interface IDict { [key: string]: string }
